import * as ɵngcc0 from '@angular/core';
import * as ɵngcc1 from './components/multiple-file-upload/file-upload.component';
import * as ɵngcc2 from './components/file-list/file-upload-list-item.component';
import * as ɵngcc3 from './components/file-list/file-upload-icon.component';
import * as ɵngcc4 from './components/drop-zone/file-upload-drop-zone.component';
import * as ɵngcc5 from './components/attribute/file-upload-attr.component';
import * as ɵngcc6 from './directives/validators.directive';
import * as ɵngcc7 from './directives/attribute.directive';
import * as ɵngcc8 from './directives/discard.directive';
import * as ɵngcc9 from './directives/native.directive';
import * as ɵngcc10 from './components/simple-file-upload/simple-file-upload.component';
import * as ɵngcc11 from '@angular/common';
export { FileUploadComponent } from './components/multiple-file-upload/file-upload.component';
export { FileUploadDropZoneComponent } from './components/drop-zone/file-upload-drop-zone.component';
export { FileUploadAttributeComponent } from './components/attribute/file-upload-attr.component';
export { SimpleFileUploadComponent } from './components/simple-file-upload/simple-file-upload.component';
export { FileSizeValidator, FilesLimitValidator, FilesAcceptValidator } from './directives/validators.directive';
export { FilesAcceptDirective } from './directives/attribute.directive';
export { FilesDiscardDirective } from './directives/discard.directive';
export { FilesNativeDirective } from './directives/native.directive';
export { FileUploadControl } from './helpers/control.class';
export { FileUploadValidators, ValidationErrors, ValidatorFn } from './helpers/validators.class';
export { FileUploadTypes } from './helpers/file-types.class';
export { FileUploadService } from './services/file-upload.service';
export declare class NgxFileUploaderModule {
    ngDoBootstrap(): void;
    static ɵfac: ɵngcc0.ɵɵFactoryDeclaration<NgxFileUploaderModule, never>;
    static ɵmod: ɵngcc0.ɵɵNgModuleDeclaration<NgxFileUploaderModule, [typeof ɵngcc1.FileUploadComponent, typeof ɵngcc2.FileUploadListItemComponent, typeof ɵngcc3.FileUploadIconComponent, typeof ɵngcc4.FileUploadDropZoneComponent, typeof ɵngcc5.FileUploadAttributeComponent, typeof ɵngcc6.FileSizeValidator, typeof ɵngcc6.FilesLimitValidator, typeof ɵngcc6.FilesAcceptValidator, typeof ɵngcc7.FilesAcceptDirective, typeof ɵngcc8.FilesDiscardDirective, typeof ɵngcc9.FilesNativeDirective, typeof ɵngcc10.SimpleFileUploadComponent], [typeof ɵngcc11.CommonModule], [typeof ɵngcc1.FileUploadComponent, typeof ɵngcc4.FileUploadDropZoneComponent, typeof ɵngcc2.FileUploadListItemComponent, typeof ɵngcc5.FileUploadAttributeComponent, typeof ɵngcc6.FileSizeValidator, typeof ɵngcc6.FilesLimitValidator, typeof ɵngcc6.FilesAcceptValidator, typeof ɵngcc7.FilesAcceptDirective, typeof ɵngcc8.FilesDiscardDirective, typeof ɵngcc10.SimpleFileUploadComponent]>;
    static ɵinj: ɵngcc0.ɵɵInjectorDeclaration<NgxFileUploaderModule>;
}

//# sourceMappingURL=ngx-file-uploader.module.d.ts.map